#ifndef MERGESTREAM_H
#define MERGESTREAM_H

#include <dol.h>
#include "jpeg.h"

#define PORT_MERGESTREAM_IN1   1
#define PORT_MERGESTREAM_IN2   2

//#define VSPVIEWER

#ifdef VSPVIEWER
//#include "LIBv3.h"
//#include "apmc_test.h"
//#include "general_lib.h"
//#include "magicV_regs.h"
//#include "gnam_lib.h"
//#include "gnam_magic_lib.h"
#define DDEV_BASE_ADDR 0xFF000000

// copied from module implementation
#define DD_MAXDIM 1024
#define ADDR_DD_FRAM       0x0000
#define ADDR_DD_REGS       (DD_MAXDIM * DD_MAXDIM * 4)
#define ADDR_DD_RESX       (ADDR_DD_REGS + 0x0000)
#define ADDR_DD_RESY       (ADDR_DD_REGS + 0x0004)
#define ADDR_DD_REFR       (ADDR_DD_REGS + 0x0008)
#define DD_MEM_SIZE        ( (DD_MAXDIM * DD_MAXDIM * 4) + 3 * 4 ) 

#endif

//local variables
typedef struct  _local_states {
    unsigned int x_size;
    unsigned int y_size;
    int port_count;
    unsigned int ii;
    int num_iter; // nummber of fire
    unsigned char display_buffer[MAX_WIDTH * MAX_HEIGHT];
#ifdef VIEWER
    CImgDisplay *main_disp;
#endif
#ifdef VSPVIEWER
  int *  c_ddev_base;
  int *  c_ddev_resx;
  int *  c_ddev_resy;
  int *  c_ddev_refr;
  // int * const c_ddev_fram = (int *) (DDEV_BASE_ADDR + ADDR_DD_FRAM);
  unsigned int *vsp_buffer;
#endif

} Mergestream_State;

void mergestream_init(DOLProcess *);
int mergestream_fire(DOLProcess *);

#endif
